**** :   ************************************************
**** Copyright (c) I.Orlov *********************************************
****    ******************************************
**** : ********************************************************
**** tcFullTableName -   dbf- ****************************
**** tcFullIndexName -     *********************
**** tcNewAliasName -    *****************************
**** tnTypeOpen -  : share:0 | exclusive:1 ******************
**** :     ****************************
**** : 0,        ****

****  : ***************************************************
**** func_OpenTable('\\server1\t1.dbf','\\server1\t1.cdx','table1',0) **
**** func_OpenTable('\\server1\t1.dbf','','table1',1) ******************
 

FUNCTION func_OpenTable
	PARAMETERS tcFullTableName,tcFullIndexName,tcNewAliasName,tnTypeOpen

	PRIVATE i &&   
	PRIVATE pnArrayLength &&  
	PRIVATE pcErrorStatus &&     (  )

	i = 0
	m.pnArrayLength = 0
	m.pcErrorStatus = ON('ERROR')

****  
	ON ERROR RETURN ERROR()

****      
	m.pnArrayLength = AUSED(AliasArray)
****   -  0, ...
	IF m.pnArrayLength > 0 THEN
		FOR i = 1 TO m.pnArrayLength
****   =  _=__
			IF LOWER(DBF(AliasArray(i,1))) == LOWER(tcFullTableName) AND;
					LOWER(AliasArray(i,1)) == LOWER(tcNewAliasName) THEN
****  _=__
				IF (ISEXCLUSIVE(AliasArray(i,1)) = .F. AND tnTypeOpen = 0) OR;
						(ISEXCLUSIVE(AliasArray(i,1)) = .T. AND tnTypeOpen = 1) THEN
****   
					IF tcFullIndexName <> '' THEN
						SET INDEX TO (tcFullIndexName)
					ENDIF
					RELEASE AliasArray
					SELECT &tcNewAliasName
					ON ERROR &pcErrorStatus
					RETURN 0
				ENDIF
			ENDIF
****   =  _=__
			IF LOWER(DBF(AliasArray(i,1))) == LOWER(tcFullTableName) OR;
					LOWER(AliasArray(i,1)) == LOWER(tcNewAliasName) THEN
****  
				SELECT &AliasArray(i,1)
				USE
				EXIT
			ENDIF
		ENDFOR
	ENDIF

****    
	RELEASE AliasArray

****   , ...
	IF tcFullIndexName <> '' THEN
		IF tnTypeOpen = 0 THEN
			USE (tcFullTableName) INDEX (tcFullIndexName) IN 0 ALIAS &tcNewAliasName SHARED
		ELSE
			USE (tcFullTableName) INDEX (tcFullIndexName) IN 0 ALIAS &tcNewAliasName EXCLUSIVE
		ENDIF
****    , ...
	ELSE
		IF tnTypeOpen = 0 THEN
			USE (tcFullTableName) IN 0 ALIAS &tcNewAliasName SHARED
		ELSE
			USE (tcFullTableName) IN 0 ALIAS &tcNewAliasName EXCLUSIVE
		ENDIF
	ENDIF
****       
	ON ERROR &pcErrorStatus
	RETURN 0

ENDFUNC

